
#include <iostream>
#include <iomanip>
#include <sstream>
#include <fstream>
using namespace std;

int tests_passed = 0;
int points = 0;

void addPoints(int test_number) {
	switch (test_number) {
	case 1:
		points += 3;
		break;
	case 2:
		points += 3;
		break;
	case 3:
		points += 2;
		break;
	case 4:
		points += 3;
		break;
	case 5:
		points += 2;
		break;
	case 6:
		points += 2;
		break;
	case 7:
		points += 2;
		break;
	case 8:
		points += 3;
		break;
	case 9:
		points += 3;
		break;
	case 10:
		points += 3;
		break;
	case 11:
		points += 3;
		break;
	case 12:
		points += 2;
		break;
	case 13:
		points += 4;
		break;
	}
}

// Funkcija koja poredi Vas izlaz sa ocekivanim izlazom za odgovarajuci test primer
void checkOutput(const string& log_filename, int test_number) {

	ifstream correct_output("correct_log_" + to_string(test_number) + ".txt");
	stringstream ss_correct;
	ss_correct << correct_output.rdbuf(); correct_output.close();
	string correct_file_system = ss_correct.str();

	ifstream student_output(log_filename);
	stringstream ss_student;
	ss_student << student_output.rdbuf(); student_output.close();
	string student_file_system = ss_student.str();

	if (student_file_system != "" && student_file_system == correct_file_system) {
		cout << "Test " + to_string(test_number) + ": PASSED" << endl;
		addPoints(test_number);
		tests_passed++;
	}
	else {
		cout << "Test " + to_string(test_number) + ": FAILED" << endl;
	}

}

void test(int test_number) {

	fstream file("student_log_" + to_string(test_number) + ".txt", ios::out);

	Person* person_1 = nullptr;
	Person* person_2 = nullptr;
	Person* person_3 = nullptr;
	const Person* const_person = nullptr;

	TreeNode* tree_node_1 = nullptr;
	TreeNode* tree_node_2 = nullptr;
	TreeNode* tree_node_3 = nullptr;

	FamilyTree* family_tree = nullptr;

	FamilyTreeAnalyzer* analyzer = nullptr;

	switch (test_number) {
	case 1:
		person_1 = new Person("Marko", "Markovic");
		file << *person_1;
		break;
	case 2:
		person_1 = new Person("Marko", "Markovic");
		person_1->setFatherName("Nikola");
		file << *person_1;
		break;
	case 3:
		const_person = new Person("Marko", "Markovic");
		file << const_person->getName();
		break;
	case 4:
		person_1 = new Person("Marko", "Markovic");
		person_2 = new Person("Nikola", "Markovic");
		tree_node_1 = new TreeNode(person_1);
		tree_node_2 = new TreeNode(person_2);
		tree_node_1->setFather(tree_node_2);
		file << *tree_node_1->getFather()->getPerson();
		break;
	case 5:
		person_1 = new Person("Marko", "Markovic");
		person_2 = new Person("Nikola", "Markovic");
		tree_node_1 = new TreeNode(person_1);
		tree_node_2 = new TreeNode(person_2);
		tree_node_2->addDescendant(tree_node_1);
		file << *tree_node_2->getDescendant(0)->getPerson();
		break;
	case 6:
		person_1 = new Person("Marko", "Markovic");
		person_2 = new Person("Nikola", "Markovic");
		person_3 = new Person("Milica", "Markovic");
		tree_node_1 = new TreeNode(person_1);
		tree_node_2 = new TreeNode(person_2);
		tree_node_3 = new TreeNode(person_3);
		tree_node_2->addDescendant(tree_node_1);
		tree_node_2->addDescendant(tree_node_3);
		file << tree_node_2->getDescendantNumber();
		break;
	case 7:
		try {
			person_1 = new Person("Marko", "Markovic");
			person_2 = new Person("Nikola", "Markovic");
			person_3 = new Person("Milica", "Markovic");
			tree_node_1 = new TreeNode(person_1);
			tree_node_2 = new TreeNode(person_2);
			tree_node_3 = new TreeNode(person_3);
			tree_node_2->addDescendant(tree_node_1);
			tree_node_2->addDescendant(tree_node_3);
			tree_node_2->getDescendant(2);
			file << "Neuspesno uhvacena greska.";
		}
		catch (IndexException e) {
			file << "Uspesno uhvacena greska.";
		}
		break;
	case 8:
		family_tree = new FamilyTree("Markovic", "input_8.txt");
		file << *family_tree->getRootNode()->getPerson() << endl;
		file << family_tree->getRootNode()->getDescendantNumber();
		break;
	case 9:
		family_tree = new FamilyTree("Markovic", "input_9.txt");
		file << *family_tree->getRootNode()->getPerson() << endl;
		file << family_tree->getRootNode()->getDescendantNumber() << endl;
		file << *family_tree->getRootNode()->getDescendant(0)->getPerson() << endl;
		file << family_tree->getRootNode()->getDescendant(0)->getDescendantNumber();
		break;
	case 10:
		family_tree = new FamilyTree("Markovic", "input_10.txt");
		file << *family_tree->getRootNode()->getPerson() << endl;
		file << family_tree->getRootNode()->getDescendantNumber() << endl;
		file << *family_tree->getRootNode()->getDescendant(0)->getPerson() << endl;
		file << family_tree->getRootNode()->getDescendant(0)->getDescendantNumber();
		break;
	case 11:
		family_tree = new FamilyTree("Markovic", "input_11.txt");
		analyzer = new FamilyTreeAnalyzer(*family_tree);
		analyzer->printSubtree(file);
		break;
	case 12:
		family_tree = new FamilyTree("Markovic", "input_12.txt");
		analyzer = new FamilyTreeAnalyzer(*family_tree);
		analyzer->moveToDescendant(0);
		analyzer->moveToDescendant(1);
		analyzer->moveToFather();
		analyzer->printSubtree(file);
		break;
	case 13:
		family_tree = new FamilyTree("Markovic", "input_13.txt");
		analyzer = new FamilyTreeAnalyzer(*family_tree);
		analyzer->moveToDescendant(0);
		analyzer->moveToDescendant(0);
		analyzer->printSiblings(file);
		break;
	}
	
	delete person_1;
	delete person_2;
	delete person_3;
	delete const_person;

	delete tree_node_1;
	delete tree_node_2;
	delete tree_node_3;

	delete family_tree;

	delete analyzer;

	file.close();

	checkOutput("student_log_" + to_string(test_number) + ".txt", test_number);
}

int main() {

	// Izmeniti elemente niza u zavisnosti od testova koje zelite da pokrenete!
	int active_tests[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 };
	int number_of_tests = sizeof(active_tests) / sizeof(int);

	cout << "============================================" << endl;
	cout << "TESTING FILE_SYSTEM" << endl << endl;
	cout << "Executing tests: ";
	for (int i = 0; i < number_of_tests; i++) cout << active_tests[i] << (i < number_of_tests - 1 ? ", " : "");
	cout << endl;

	for (int i = 0; i < number_of_tests; i++) test(active_tests[i]);

	cout << "============================================" << endl;
	cout << "Tests passed count: " << tests_passed << endl;
	cout << "Points: " << points << endl;

	return 0;
}